﻿# -*- coding: utf-8 -*-
"""
Created on Thu Aug 04 15:38:36 2016

@author: Anita_hsong
"""

import pandas as pd
import matplotlib.pyplot as plt


#1）从文件ENB2012_data.xlsx中读取数据，列索引按照ENB2012.names中给出的说明进行添加。

filename = 'ENB2012_data.xlsx'
colname = ['Relative Compactness', 'Surface Area', 'Wall Area', 'Roof Area','Overall Height', 'Orientation','Glazing Area', 'Glazing Area Distribution' , 'Heating Load', 'Cooling Load']
data = pd.io.excel.read_excel(filename, header = None, names = colname, skiprows = 1 )
print(data.ix[0:5])


#2)统计各列数据的均值和方差，以及中位数。
print('mean:\n', data.mean())
print('meidan:\n', data.median())
print('std:\n', data.std())



#3）在一张图中分别绘制Surface Area列与Heating Load以及Cooling Load两张散点子图。
fig = plt.figure( figsize=(6,6) )
ax1 = fig.add_subplot(2,1,1)
ax1.scatter( data['Surface Area'],data['Heating Load'],marker='*',label='(Surface Area,Heating Load)')
ax2 = fig.add_subplot(2,1,2)
ax2.scatter( data['Surface Area'], data['Cooling Load'],marker='*',label='(Surface Area,Cooling Load)' )
plt.show()


#4）将数据分割为训练集和测试集，在训练集上训练模型，输出回归模型参数，分别计算模型在训练集和测试集上的均方误差和决定系数。
X = data.iloc[:, 0:8].values.astype(float)
y1 = data.iloc[:, 8].values.astype(float)
y2 = data.iloc[:, 9].values.astype(float)

#Learn the linear regression model
from sklearn import model_selection
from sklearn.linear_model import LinearRegression

## 划分训练集与测试集
X_train, X_test, y_train, y_test = model_selection.train_test_split(
                           X, y1, test_size=0.35, random_state=1)

linreg = LinearRegression()
linreg.fit(X_train, y_train)
#输出横截距和相关系数
print('linreg.intercept\n', linreg.intercept_)
print('linreg.coef\n',linreg.coef_)


#性能评价
from sklearn import metrics

y_train_pred = linreg.predict(X_train)
print( 'The mean squar error of train is : {:.3f}'.format(metrics.mean_squared_error(y_train, y_train_pred) ) )
predict_score = linreg.score(X_train,y_train)
print('Train decision coeficient is : {:.2f}'.format(predict_score))
y_test_pred = linreg.predict(X_test)
print ( 'The mean squar error of test is {:.3f}'.format(metrics.mean_squared_error(y_test, y_test_pred) ) )
predict_score = linreg.score(X_test,y_test)
print('Train decision coeficient is : {:.2f}'.format(predict_score))


